#ifndef _H_EC0926DEFDE9EB4F8DCAE49E4AFD2EF6_Twist2DStamped_DCPS_H_
#define _H_EC0926DEFDE9EB4F8DCAE49E4AFD2EF6_Twist2DStamped_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Twist2DStamped_.h"


namespace nav_2d_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class Twist2DStamped_TypeSupportInterface;

            typedef Twist2DStamped_TypeSupportInterface * Twist2DStamped_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Twist2DStamped_TypeSupportInterface> Twist2DStamped_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Twist2DStamped_TypeSupportInterface> Twist2DStamped_TypeSupportInterface_out;


            class Twist2DStamped_DataWriter;

            typedef Twist2DStamped_DataWriter * Twist2DStamped_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Twist2DStamped_DataWriter> Twist2DStamped_DataWriter_var;
            typedef DDS_DCPSInterface_out < Twist2DStamped_DataWriter> Twist2DStamped_DataWriter_out;


            class Twist2DStamped_DataReader;

            typedef Twist2DStamped_DataReader * Twist2DStamped_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Twist2DStamped_DataReader> Twist2DStamped_DataReader_var;
            typedef DDS_DCPSInterface_out < Twist2DStamped_DataReader> Twist2DStamped_DataReader_out;


            class Twist2DStamped_DataReaderView;

            typedef Twist2DStamped_DataReaderView * Twist2DStamped_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Twist2DStamped_DataReaderView> Twist2DStamped_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Twist2DStamped_DataReaderView> Twist2DStamped_DataReaderView_out;

            struct Twist2DStamped_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Twist2DStamped_, struct Twist2DStamped_Seq_uniq_> Twist2DStamped_Seq;
            typedef DDS_DCPSSequence_var < Twist2DStamped_Seq> Twist2DStamped_Seq_var;
            typedef DDS_DCPSSequence_out < Twist2DStamped_Seq> Twist2DStamped_Seq_out;

            class  Twist2DStamped_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Twist2DStamped_TypeSupportInterface_ptr _ptr_type;
                typedef Twist2DStamped_TypeSupportInterface_var _var_type;

                static Twist2DStamped_TypeSupportInterface_ptr _duplicate (Twist2DStamped_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Twist2DStamped_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Twist2DStamped_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Twist2DStamped_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Twist2DStamped_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Twist2DStamped_TypeSupportInterface () {};
                ~Twist2DStamped_TypeSupportInterface () {};
            private:
                Twist2DStamped_TypeSupportInterface (const Twist2DStamped_TypeSupportInterface &);
                Twist2DStamped_TypeSupportInterface & operator = (const Twist2DStamped_TypeSupportInterface &);
            };

            class  Twist2DStamped_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Twist2DStamped_DataWriter_ptr _ptr_type;
                typedef Twist2DStamped_DataWriter_var _var_type;

                static Twist2DStamped_DataWriter_ptr _duplicate (Twist2DStamped_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Twist2DStamped_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Twist2DStamped_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Twist2DStamped_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Twist2DStamped_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Twist2DStamped_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Twist2DStamped_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Twist2DStamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Twist2DStamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Twist2DStamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Twist2DStamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Twist2DStamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Twist2DStamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Twist2DStamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Twist2DStamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Twist2DStamped_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Twist2DStamped_& instance_data) = 0;

            protected:
                Twist2DStamped_DataWriter () {};
                ~Twist2DStamped_DataWriter () {};
            private:
                Twist2DStamped_DataWriter (const Twist2DStamped_DataWriter &);
                Twist2DStamped_DataWriter & operator = (const Twist2DStamped_DataWriter &);
            };

            class  Twist2DStamped_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Twist2DStamped_DataReader_ptr _ptr_type;
                typedef Twist2DStamped_DataReader_var _var_type;

                static Twist2DStamped_DataReader_ptr _duplicate (Twist2DStamped_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Twist2DStamped_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Twist2DStamped_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Twist2DStamped_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Twist2DStamped_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Twist2DStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Twist2DStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Twist2DStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Twist2DStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Twist2DStamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Twist2DStamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Twist2DStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Twist2DStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Twist2DStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Twist2DStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Twist2DStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Twist2DStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Twist2DStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Twist2DStamped_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Twist2DStamped_& instance) = 0;

            protected:
                Twist2DStamped_DataReader () {};
                ~Twist2DStamped_DataReader () {};
            private:
                Twist2DStamped_DataReader (const Twist2DStamped_DataReader &);
                Twist2DStamped_DataReader & operator = (const Twist2DStamped_DataReader &);
            };

            class  Twist2DStamped_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Twist2DStamped_DataReaderView_ptr _ptr_type;
                typedef Twist2DStamped_DataReaderView_var _var_type;

                static Twist2DStamped_DataReaderView_ptr _duplicate (Twist2DStamped_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Twist2DStamped_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Twist2DStamped_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Twist2DStamped_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Twist2DStamped_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Twist2DStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Twist2DStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Twist2DStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Twist2DStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Twist2DStamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Twist2DStamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Twist2DStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Twist2DStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Twist2DStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Twist2DStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Twist2DStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Twist2DStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Twist2DStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Twist2DStamped_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Twist2DStamped_& instance) = 0;

            protected:
                Twist2DStamped_DataReaderView () {};
                ~Twist2DStamped_DataReaderView () {};
            private:
                Twist2DStamped_DataReaderView (const Twist2DStamped_DataReaderView &);
                Twist2DStamped_DataReaderView & operator = (const Twist2DStamped_DataReaderView &);
            };
        }

    }

}

#endif
